# zip files
import os
import tarfile
import zipfile

pdir = os.getcwd()

dest_dir = os.path.join(pdir,'dist')
if not os.path.exists(dest_dir):
    os.mkdir(dest_dir)
name = 'brython-firefoxos-memos'
dest_path = os.path.join(dest_dir,name)

def is_valid(filename):
    if filename.startswith('.'):
        return False
    for ext in ['bat','log','gz','pyc']:
        if filename.lower().endswith('.%s' %ext):
            return False
    return True

dist_gz = tarfile.open(dest_path+'.gz',mode='w:gz')

for path in os.listdir(pdir):
    if not is_valid(path):
        continue
    abs_path = os.path.join(pdir,path)
    if os.path.isdir(abs_path) and path=="dist":
        continue
    print('add',path)
    dist_gz.add(os.path.join(pdir,path),
        arcname=os.path.join(name,path))

dist_gz.close()

dist_zip = zipfile.ZipFile(dest_path+'.zip',mode='w',compression=zipfile.ZIP_DEFLATED)

for dirpath,dirnames,filenames in os.walk(pdir):
    print(dirpath)
    for path in filenames:
        if not is_valid(path):
            continue
        abs_path = os.path.join(pdir,dirpath,path)
        #print('add',path)
        dist_zip.write(os.path.join(dirpath,path),
            arcname=os.path.join(name,dirpath[len(pdir)+1:],path))
    if 'dist' in dirnames:
        dirnames.remove('dist')
    if '.hg' in dirnames:
        dirnames.remove('.hg')
    for dirname in dirnames:
        if dirname == 'dist':
            continue

dist_zip.close()
